<?php require( '../../../wp-load.php' ); ?>
<!doctype>
<html>
<head>
<style type="text/css">
body {
    margin:6px 0 0 1px; 
    padding:0; 
    font-family:"Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; 
    font-size:11px; 
}
</style>
</head>
<body>
<?php

if ( !current_user_can( 'upload_files' ) ) {
?>
    <script>
    alert('You do not have sufficient permissions to upload files.') 
    </script><?php
    wp_die( __('You do not have sufficient permissions to upload files.') );
}

// Get options:
$val_maxwidth = get_option('fastimageadder_maxwidth');
$val_featuredimg = get_option('fastimageadder_featuredimg');
$val_htmlpattern = get_option('fastimageadder_htmlpattern');
$new_width = -1;
$new_height = -1;
  
if ((isset($_GET["confirm"])))
{
    $command = "";
    if ($_GET["confirm"] == "url")
    {
        if (isset($_GET["url"]))
        {
            $url = $_GET["url"];
        }

        if (!is_url($url))
        {
            echo "Not a valid URL.";
            ?> 
            
            <a href="javascript:parent.fast_image_adder_reset();" style="text-decoration:underline" onclick="parent.fast_image_adder_reset();">Reset this form</a> 
            <script>
                parent.document.getElementById("fast_image_adder_loading_icon").style.display = "none";
            </script>
            <?php
        }
        else
        {
            // Is a valid URL, so let's try to upload this file
            
            if (isset($_GET["name"]) && (trim($_GET["name"] != "")))
            {
            $suggested_name = $_GET["name"];
            }
            else
            {
            $suggested_name = "unnamed";
            }

            // Get the post ID
            $post_id = $_GET["post_id"];
            
            // Setup the attach ID so we can debug later if needed
            $attach_id = "-1";

            // Get the caption, and remove any pesky double quotes
            $new_caption = stripslashes($_GET["caption"]);
            $new_caption = str_replace('"','',$new_caption);

            // Make a filesystem version of the name, in case it contains odd characters
            $suggested_name_filesystem = safe_filename($suggested_name);

            // Check to see if this is test mode
            $test_mode = (isset($_GET["test"]));

            // Attempt to retrieve the file 
            $upload_dir = wp_upload_dir(); 
            $path = $upload_dir['path']; 
            $new_filename = $suggested_name_filesystem . "_" . random_filename() . substr($url,strrpos($url,"."));

            // If we are not in test mode, get the file and resize it         
            if ($test_mode === FALSE)
            {
                $image_data = file_get_contents($url);
                file_put_contents($path . "/" . $new_filename,$image_data);
                resize($path . "/" . $new_filename, $new_height, $new_width, $val_maxwidth, $path . "/" . $new_filename);

                $wp_filetype = wp_check_filetype($path . "/" . $new_filename, null );
                $wp_upload_dir = wp_upload_dir();
                $attachment = array(
                  'guid' => $upload_dir['url'] . "/" . $new_filename,
                  'post_mime_type' => $wp_filetype['type'],
                  'post_title' => $suggested_name,
                  'post_content' => $new_caption,
                  'post_status' => 'inherit'
                );
                $attach_id = wp_insert_attachment( $attachment, $path . "/" . $new_filename, $post_id );
                

                // you must first include the image.php file
                // for the function wp_generate_attachment_metadata() to work
                require_once(ABSPATH . 'wp-admin/includes/image.php');
                $attach_data = wp_generate_attachment_metadata( $attach_id, $path . "/" . $new_filename );
                wp_update_attachment_metadata( $attach_id, $attach_data );
                
                // Using the Title as the Alt Text
                update_post_meta($attach_id, "_wp_attachment_image_alt", $suggested_name);
            }   

            //add creative commons license if one is selected
            $new_license = '';
            if (isset($_GET["license"]) && (trim($_GET["license"] != ""))) 
            {
                $license = $_GET["license"];
                if ($license == "none") 
                {
                   $new_license = '';
                } 
                else 
                {
                    $new_license = 'https://creativecommons.org/licenses/' . $license . '/2.0/';
                }
            }
            
            $new_url = $upload_dir['url'] . "/" . $new_filename;
             
            // Setup the HTML snippet to include the proposed text
            $new_html_snippet = str_replace("$1", $new_url, $val_htmlpattern);
            $new_html_snippet = str_replace("$2", $new_filename, $new_html_snippet);
            $new_html_snippet = str_replace("$3", $suggested_name, $new_html_snippet);
            $new_html_snippet = str_replace("$4", $new_width, $new_html_snippet);
            $new_html_snippet = str_replace("$5", $new_height, $new_html_snippet);
            $new_html_snippet = str_replace("$6", $new_caption, $new_html_snippet);
            $new_html_snippet = str_replace("$7", $new_license, $new_html_snippet);
            
            //gets image element from html snippet
            $featured_img_html_snippet = '<img width="266" height="177" src="' . $new_url .'" class="attachment-266x266 size-266x266" alt="Woman with Notebook" sizes="(max-width: 266px) 100vw, 266px">';      
            
            
            // Set up preview for below, as well as "Uplodaed as" text
            if ($test_mode === FALSE)
            { 
                $preview_img_html_snippet = '<img src="' . $new_url . '" style="height:180px; padding:10px; float:right; clear:right;">';
                echo "Uploaded as " . $new_url . ".";
            }
            else
            {
                $preview_img_html_snippet = '<img src="' . $url . '" style="height:180px; padding:10px; float:right; clear:right;">';
                echo "Example test URL: " . $new_url . ".";  
            }

            
            ?>
            <strong>Click HTML below to select text.</strong>
            
            <div style="float:right">
                <a href="javascript:parent.fast_image_adder_reset();" style="text-decoration:underline" onclick="parent.fast_image_adder_reset();">Reset this form</a> 
            </div>
            <?php
                        
            // See if there is already a featured image on this post
            $existing_featured_image = ('' !== get_the_post_thumbnail($post_id));
            
            // Adjust size of text area based on whether or not we are showing the preview at right
            $display_preview_at_right = (($val_featuredimg !== "on") || (($val_featuredimg === "on") && ($existing_featured_image === true)));
            
            if ($display_preview_at_right === true)
            {
               $textarea_width = "58%";
               $textarea_height = "150px";
               $box_height_px = "215";   
               echo $preview_img_html_snippet;
            }
            else
            {  
               $textarea_width = "100%";
               $textarea_height = "75";
               $box_height_px = "125"; 
            }

             
            if ($existing_featured_image === true) 
            {
              // If the post already has a featured image, do nothing.
            } 
            else 
            {
                // The post does NOT have a feature image. Check the setting (but do nothing if we're in test mode):
                if (($val_featuredimg === "on") && ($test_mode === FALSE))
                {
                    set_post_thumbnail($post_id,$attach_id);
                    
                    ?> 
                    <script> //adds featured image preview
                        let imageElement = '<?php echo $featured_img_html_snippet; ?>';
                        parent.document.getElementById("set-post-thumbnail").href = "//wp-admin/media-upload.php?post_id=<?php echo $post_id; ?>&amp;type=image&amp;TB_iframe=1";parent.document.getElementById("set-post-thumbnail").innerHTML = imageElement;
                        parent.document.getElementById("postimagediv").getElementsByClassName("inside")[0].insertAdjacentHTML('beforeend', '<p class="hide-if-no-js howto" id="set-post-thumbnail-desc">Click the image to edit or update</p><p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail">Remove featured image</a></p><input type="hidden" id="_thumbnail_id" name="_thumbnail_id" value="<?php echo $attach_id;?>">');
                    </script>
                    <?php
                }
            }
            

            
            // No need to show the picture in both places if they have the featured image setting and we used this
            $show_image_preview_below = (($val_featuredimg !== "on") || (($val_featuredimg === "on") && ($existing_featured_image === true)));  
            ?>
            <script>
                parent.document.getElementById("fast_image_adder_iframe").style.height = "<?php echo $box_height_px;?>px";
                parent.document.getElementById("fast_image_adder_loading_icon").style.display = "none";
            </script>
            <textarea style="float:left; width:<?php echo $textarea_width;?>; height:<?php echo $textarea_height;?>; margin-bottom:5px;" onclick="this.select()"><?=htmlentities($new_html_snippet)?></textarea><br />

            <div style="clear:left">
            <?php 
            // No need to show the picture in both places if they have the featured image setting and we used this
            if ($display_preview_at_right === true)
            {
                echo "Image previewed to the right <em>without</em> your custom parameters. To use image in body of post, copy and paste code above. To delete picture, go the Media library."; 
            }
            else
            {
                echo "Image is set to Featured Image and is visible in that panel. To also use image in body of post, copy and paste code above. To delete picture, click on thumbnail or go the Media library.";
            }
            ?></div><?php
        }
    }
  }
else
{
    echo "This script is internal to the Fast Image Adder plugin and should not be executed directly.";
}
  
function is_url($string)   
{ 
 //$ret = ereg("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?",   $string, $regs); 
 
 if (filter_var($string, FILTER_VALIDATE_URL) ) 
   return true; 
 else
   return false;
} 


  
  // From http://www.lost-in-code.com/programming/php-code/php-random-string-with-numbers-and-letters/
  function random_filename() {
    $length = 10;
    $characters = '0123456789abcdefghijklmnopqrstuvwxyz';
    $string = "";    
    for ($p = 0; $p < $length; $p++) {
        $string .= $characters[mt_rand(0, strlen($characters))];
    }

    return $string;
   }
   
  
  // From http://php.net/manual/en/function.imagecreatefromjpeg.php 
  function resize($img, &$thumb_height, &$thumb_width, $max_width, $newfilename)
  {

    //Check if GD extension is loaded
    if (!extension_loaded('gd') && !extension_loaded('gd2'))
    {
        trigger_error("GD is not loaded", E_USER_WARNING);
        return false;
    }

    //Get Image size info
    list($width_orig, $height_orig, $image_type) = getimagesize($img);
    
    // Just exit if the original image is already a good size
    if ($width_orig <= $max_width)
    {
        $thumb_height = $height_orig;
        $thumb_width = $width_orig;
        return;
    }
   
    switch ($image_type)
    {
        case 1: $im = imagecreatefromgif($img); break;
        case 2: $im = imagecreatefromjpeg($img);  break;
        case 3: $im = imagecreatefrompng($img); break;
        default:  trigger_error('Unsupported filetype!', E_USER_WARNING);  break;
    }
   
    /*** calculate the aspect ratio ***/
    $aspect_ratio = (float) $height_orig / $width_orig;

    /*** calulate the thumbnail width based on the height ***/
    $thumb_height = round($thumb_width * $aspect_ratio);
  
    // Start with original:
    $thumb_width = $width_orig;
    while($thumb_width>$max_width)
    {
        $thumb_width-=10;
        $thumb_height = round($thumb_width * $aspect_ratio);
    }
    $newImg = imagecreatetruecolor($thumb_width, $thumb_height);
   
    /* Check if this image is PNG or GIF, then set if Transparent*/ 
    if(($image_type == 1) OR ($image_type==3))
    {
        imagealphablending($newImg, false);
        imagesavealpha($newImg,true);
        $transparent = imagecolorallocatealpha($newImg, 255, 255, 255, 127);
        imagefilledrectangle($newImg, 0, 0, $thumb_width, $thumb_height, $transparent);
    }
    imagecopyresampled($newImg, $im, 0, 0, 0, 0, $thumb_width, $thumb_height, $width_orig, $height_orig);
   
    //Generate the file, and rename it to $newfilename
    switch ($image_type)
    {
        case 1: imagegif($newImg,$newfilename); break;
        case 2: imagejpeg($newImg,$newfilename);  break;
        case 3: imagepng($newImg,$newfilename); break;
        default:  trigger_error('Failed resize image!', E_USER_WARNING);  break;
    }
 
    return;
  }


  // From http://us.php.net/manual/en/function.preg-replace.php#96586
  function safe_filename($str)
  {
    return 
      strtolower(preg_replace(array('/[^a-zA-Z0-9 -]/', '/[ -]+/', '/^-|-$/'),  array('', '_', ''), $str));
  }

?>
</body>
</html>
